config/routes.rb
#
# TODO: Clean up routing.
#
Rails.application.routes.draw do
  concern :tamplate_common do
    get 'orphaned_templates', on: :collection
  end

  concern :previewable do
    post 'preview', on: :collection
  end

  resources :global_issue_templates, except: [:edit], concerns: %i[tamplate_common previewable]

  # for project issue template
  resources :projects, only: [] do
    resources :issue_templates, except: [:edit], concerns: [:tamplate_common] do
      post 'set_pulldown', on: :collection
      get 'list_templates', on: :collection
    end

    resources :issue_templates_settings, only: [:edit], concerns: [:previewable] do
      patch 'edit', on: :collection
    end

    get 'issue_templates_settings', to: 'issue_templates_settings#index'

    resources :note_templates, except: [:edit]
  end

  resources :issue_templates, only: %i[load preview load_selectable_fields], concerns: [:previewable] do
    post 'load', on: :collection
    get 'load_selectable_fields', on: :collection
  end

  # for note temlate
  resources :note_templates, only: %i[load preview list_templates] do
    post 'load', on: :collection
    get 'list_templates', on: :collection
  end
end

app/models/global_issue_template.rb
# frozen_string_literal: true

class GlobalIssueTemplate < ActiveRecord::Base
  include Redmine::SafeAttributes
  include Concerns::IssueTemplate::Common
  validates :title, uniqueness: { scope: :tracker_id }
  has_and_belongs_to_many :projects

  acts_as_positioned scope: [:tracker_id]

  safe_attributes 'title',
                  'description',
                  'tracker_id',
                  'note',
                  'enabled',
                  'is_default',
                  'issue_title',
                  'project_ids',
                  'position',
                  'author_id',
                  'checklist_json',
                  'related_link',
                  'link_title',
                  'builtin_fields_json'

  # for intermediate table assosciations
  scope :search_by_project, lambda { |project_id|
    joins(:projects).where(projects: { id: project_id }) if project_id.present?
  }

  module Config
    JSON_OBJECT_NAME = 'global_issue_template'
  end
  Config.freeze

  #
  # In case set is_default and updated, others are also updated.
  #
  def check_default
    return unless is_default? && is_default_changed?

    self.class.search_by_tracker(tracker_id).update_all(is_default: false)
  end

  #
  # Class method
  #
  class << self
    def get_templates_for_project_tracker(project_id, tracker_id = nil)
      GlobalIssueTemplate.search_by_tracker(tracker_id)
                         .search_by_project(project_id)
                         .enabled
                         .sorted
    end
  end
end

app/controllers/global_issue_templates_controller.rb
# frozen_string_literal: true

# noinspection RubocopInspection
class GlobalIssueTemplatesController < ApplicationController
  layout 'base'
  helper :issues
  include IssueTemplatesHelper
  include Concerns::IssueTemplatesCommon
  menu_item :issues
  before_action :find_object, only: %i[show edit update destroy]
  before_action :find_project, only: %i[edit update]
  before_action :require_admin, only: %i[index new show], excep: [:preview]

  #
  # Action for global template : Admin right is required.
  #
  def index
    trackers = Tracker.all
    template_map = {}
    trackers.each do |tracker|
      tracker_id = tracker.id
      templates = GlobalIssueTemplate.search_by_tracker(tracker_id).sorted
      template_map[Tracker.find(tracker_id)] = templates if templates.any?
    end
    render layout: !request.xhr?, locals: { template_map: template_map, trackers: trackers }
  end

  def new
    # create empty instance
    @global_issue_template = GlobalIssueTemplate.new
    render render_form_params
  end

  def create
    @global_issue_template = GlobalIssueTemplate.new
    @global_issue_template.author = User.current

    begin
      @global_issue_template.safe_attributes = valid_params
    rescue ActiveRecord::SerializationTypeMismatch, Concerns::IssueTemplatesCommon::InvalidTemplateFormatError
      flash[:error] = I18n.t(:builtin_fields_should_be_valid_json, default: 'Please enter a valid JSON fotmat string.')
      render render_form_params.merge(action: :new)
      return
    end
    save_and_flash(:notice_successful_create, :new) && return
  end

  def show
    render render_form_params
  end

  def update
    begin
      @global_issue_template.safe_attributes = valid_params
    rescue ActiveRecord::SerializationTypeMismatch, Concerns::IssueTemplatesCommon::InvalidTemplateFormatError
      flash[:error] = I18n.t(:builtin_fields_should_be_valid_json, default: 'Please enter a valid JSON fotmat string.')
      render render_form_params.merge(action: :show)
      return
    end

    save_and_flash(:notice_successful_update, :show)
  end

  def edit
    # Change from request.post to request.patch for Rails4.
    return unless request.patch? || request.put?

    begin
      @global_issue_template.safe_attributes = valid_params
    rescue ActiveRecord::SerializationTypeMismatch
      flash[:error] = I18n.t(:builtin_fields_should_be_valid_json, default: 'Please enter a valid JSON fotmat string.')
      render render_form_params.merge(action: :show)
      return
    end

    save_and_flash(:notice_successful_update, :show)
  end

  def destroy
    unless @global_issue_template.destroy
      flash[:error] = l(:enabled_template_cannot_destroy)
      redirect_to action: :show, id: @global_issue_template
      return
    end

    flash[:notice] = l(:notice_successful_delete)
    redirect_to action: 'index'
  end

  # preview
  def preview
    global_issue_template = params[:global_issue_template]
    id = params[:id]
    @text = (global_issue_template ? global_issue_template[:description] : nil)
    @global_issue_template = GlobalIssueTemplate.find(id) if id
    render partial: 'common/preview'
  end

  private

  def orphaned
    GlobalIssueTemplate.orphaned
  end

  def find_project
    @projects = Project.all
  end

  def find_object
    @global_issue_template = GlobalIssueTemplate.find(params[:id])
  rescue ActiveRecord::RecordNotFound
    render_404
  end

  def save_and_flash(message, action_on_failure)
    unless @global_issue_template.save
      render render_form_params.merge(action: action_on_failure)
      return
    end

    respond_to do |format|
      format.html do
        flash[:notice] = l(message)
        redirect_to action: 'show', id: @global_issue_template.id
      end
      format.js { head 200 }
    end
  end

  def template_params
    params.require(:global_issue_template)
          .permit(:title, :tracker_id, :issue_title, :description, :note, :is_default, :enabled,
                  :author_id, :position, :related_link, :link_title, :builtin_fields,
                  project_ids: [], checklists: [])
  end

  def render_form_params
    trackers = Tracker.all
    projects = Project.all
    tracker_id = @global_issue_template.tracker_id
    custom_fields = core_fields_map_by_tracker_id(tracker_id: tracker_id)
                    .merge(custom_fields_map_by_tracker_id(tracker_id)).to_json

    { layout: !request.xhr?,
      locals: { checklist_enabled: checklist_enabled?, trackers: trackers, apply_all_projects: apply_all_projects?,
                issue_template: @global_issue_template, projects: projects, custom_fields: custom_fields.to_s,
                builtin_fields_enable: builtin_fields_enabled? } }
  end
end

app/views/global_issue_templates/_form.html.erb
<%= error_messages_for 'global_issue_template' %>
<div class='box tabular box-white'>
  <p><%= f.text_field :title, required: true, size: 80, label: l(:issue_template_name) %></p>

  <fieldset class='issue'>
    <legend class='issue'><%= l(:label_applied_for_issue) %></legend>
    <p>
      <% if issue_template.tracker.blank? %>
          <%= f.select :tracker_id, trackers.collect { |t| [t.name, t.id] }, { required: true },
                       required: true, label: l(:label_tracker) %>

          <%= h issue_template.tracker.present? ? issue_template.tracker.name :
                    l(:orphaned_template, default: 'Orphaned template from tracker') %>

      <% else %>
          <%= f.select :tracker_id, trackers.collect { |t| [t.name, t.id] }, { required: true },
                       required: true, label: l(:label_tracker), selected: issue_template.tracker.id %>
      <% end %>
    </p>
    <p><%= f.text_field :issue_title, required: false, size: 80, label: l(:issue_title) %>
      <a class='icon icon-help template-help' title='<%= l(:help_for_this_field) %>'
         data-tooltip-area='issue_title_help_area'
         data-tooltip-content='issue_title_help_content'>
        <%= l(:help_for_this_field) %>
        <span class='tooltip-area' id='issue_title_help_area'></span>
      </a>
    </p>
    <p>
      <%= f.text_area :description, cols: 78, rows: 12,
                      required: true,
                      label: l(:issue_description), class: 'wiki-edit', style: 'overflow: auto;' %>
    </p>
    <!-- for Checklist -->
    <% if checklist_enabled %>
      <p id='checklist_form'>
        <label>Checklist</label>
        <input type='text' id='checklist_text' class='edit-box'>
        <span class='icon icon-add checklist-new-only save-new-by-button' onclick='addCheckList()'></span>
        <ul class='checklist' style='padding-left: 180px;'>
          <% issue_template.checklist.each_with_index do |content, i| %>
            <li id='checklist_<%= i %>'>
              <span class='text'>
                <%= content %>
                <i class='icon icon-del' onclick='removeCheckList(this)'></i>
              </span>
              <input type='hidden' name='global_issue_template[checklists][]'
                     id='global_issue_template_checklist' value='<%= content %>'>
            </li>
          <% end %>
        </ul>
      </p>
    <% end %>

    <!-- for Builtin Fields -->
    <!-- buildin field Generator -->
    <% if builtin_fields_enable %>
    <div id="json_generator">
      <p>
        <label><%= l(:label_select_field, default: 'Select a field') %></label>
        <select v-model='newItemTitle'>
          <option v-for='(value, key) in customFields' v-bind:value='key'>
           {{ value.name }}
          </option>
        </select>
        <a class='icon icon-help template-help' title='<%= l(:help_for_this_field) %>'
         data-tooltip-area='builtin_fields_help_area'
         data-tooltip-content='builtin_fields_help_content'>
           <%= l(:help_for_this_field) %>
          <span class='tooltip-area' id='builtin_fields_help_area'></span>
        </a>
      </p>
      <p>
          <label><%= l(:field_value) %></label>
          <textarea id='issue_template_json_setting_field' v-if='fieldFormat() == "text"'
              rows='1' placeholder='<%= l(:enter_value, default: 'Please enter a value') %>' v-model='newItemValue'>
          </textarea>

          <input type='date' id='issue_template_json_setting_field' v-if='fieldFormat() == "date"' v-model='newItemValue'>

          <select v-model='newItemValue' v-if='fieldFormat() == "ratio"'>
            <option v-for="ratio in [10, 20, 30, 40, 50, 60, 70, 80, 90, 100]">{{ ratio }} %</option>
          </select>

          <select v-model='newItemValue' v-if='fieldFormat() == "list" || fieldFormat() == "bool"'>
            <option v-for="value in possibleValues()">{{ value }}</option>
          </select>
          <span style='margin-left: 4px;' class='icon icon-add' v-on:click='addField(newItemTitle, newItemValue)'>
            <%= l(:button_add) %>
          </span>
      </p>
      <div id='field_information' class='wiki' v-if='newItemTitle != ""'>
        <b><%= l(:label_field_information, default: 'Field information') %></b>
        <pre>{{ customFields[newItemTitle] }}</pre>
      </div>
      <div id='fields_setting_display_area'>
        <ul class='json-list' v-if='items.length > 0'>
          <li v-for='item in items'>
            <span v-if='customFields[item.title]'>
              <b>{{ customFields[item.title].name }}</b>: {{ item.value }} / {{ item.title }}
            </span>
            <span v-if='!customFields[item.title]'>
              <i class='issue_template help_content'>
                <%= l(:unavailable_fields_for_this_tracker, default: 'Unavailable field for this tarcker') %>
              : {{ item.value }} / {{ item.title }}
              </i>
            </span>
            <i class='icon icon-del' v-on:click='deleteField(item)'></i>
          </li>
        </ul>
        <pre id='builtin_fields_data_via_vue' style='display: none;'>{{ items }}</pre>
        <span class='icon icon-reload' id='reset-json' v-on:click='loadField()'><%= l(:button_reset) %></span>
        <span class='icon icon-checked' id='paste-json'><%= l(:button_apply) %></span>
      </div>
      <!-- buildin field Generator -->
      <p style='opacity: 0.6;'>
        <%= f.text_area :builtin_fields,
            required: false, cols: 60, rows: 4,
            label: l(:label_builtin_fields_json, default: 'JSON for fields') %>
      </p>
      <div id='builtin_fields_help_content' class='wiki' style='display: none;'>
        <%= l(:label_builtin_fields_help_message, default: 'Enter builtin filds or custom fields default values with JSON format. ') %>
      </div>
    </div>
    <% end %>
    <!-- for Builtin Fields -->

  </fieldset>
  <p>
    <%= f.text_area :note, cols: 70, rows: 3,
                    required: false,
                    label: l(:issue_template_note), style: 'overflow:auto;' %>
  </p>

  <p><%= f.text_field :related_link, type: 'url',
          size: 70, label: l(:issue_template_related_link, default: 'Related link') %>
    <a class='icon icon-help template-help' title='<%= l(:help_for_this_field) %>'
       data-template-help-target='related_link_help_content'
       data-tooltip-area='related_link_help_area'
       data-tooltip-content='related_link_help_content'>
      <%= l(:help_for_this_field) %>
      <span class='tooltip-area' id='related_link_help_area'></span>
    </a>
  </p>

  <p id='link_title_paragraph'><%= f.text_field :link_title, size: 70, label: l(:issue_template_link_title, default: 'Link title') %>
    <a class='icon icon-help template-help' title='<%= l(:help_for_this_field) %>'
       data-template-help-target='link_title_help_content'
       data-tooltip-area='link_title_help_area'
       data-tooltip-content='link_title_help_content'>
      <%= l(:help_for_this_field) %>
      <span class='tooltip-area' id='link_title_help_area'></span>
    </a>
  </p>

  <p><%= f.check_box :is_default, label: l(:field_is_default) %>
    <a class='icon icon-help template-help' title='<%= l(:help_for_this_field) %>'
       data-template-help-target='isdefault_help_content'
       data-tooltip-area='isdefault_help_area'
       data-tooltip-content='isdefault_help_content'>
      <%= l(:help_for_this_field) %>
      <span class='tooltip-area' id='isdefault_help_area'></span>
    </a>
  </p>

  <p><%= f.check_box :enabled, label: l(:label_enabled) %>
    <a class='icon icon-help template-help' title='<%= l(:help_for_this_field) %>'
       data-template-help-target='enabled_help_content'
       data-tooltip-area='enabled_help_area'
       data-tooltip-content='enabled_help_content'>
      <%= l(:help_for_this_field) %>
      <span class='tooltip-area' id='enabled_help_area'></span>
    </a>
  </p>
</div>

<%= wikitoolbar_for 'global_issue_template_description' %>


<!-- tooltip content -->
<div id='issue_title_help_content' class='wiki' style='display: none;'>
  <%= l(:help_for_issue_title) %>
</div>
<div id='isdefault_help_content' class='wiki' style='display: none;'>
  <%= l(:label_isdefault_help_message) %>
</div>
<div id='related_link_help_content' class='wiki' style='display: none;'>
  <%= l(:label_related_link_help_message, default: 'If there are some example pages or sample issues which using issue template, please specify the link. So operator can see them as an usage or example for template.') %>
</div>
<div id='link_title_help_content' class='wiki' style='display: none;'>
  <%= l(:label_link_title_help_message, default: 'If there are some example pages or sample issues which using issue template, please specify the link. So operator can see them as an usage or example for template.') %>
</div>
<div id='enabled_help_content' class='wiki' style='display: none;'>
  <%= l(:label_enabled_help_message) %>
</div>
<!-- tooltip content -->

<div class='box'>
  <% if apply_all_projects %>
      <p>
        <i class='issue_template icon settings'></i>
        <span class='issue_template help_content'>
          <%= l(:note_apply_global_template_to_all_projects_setting_enabled) %>
        </span>
        (
        <%= link_to(l(:label_settings),
                    { controller: 'settings', action: 'plugin', id: 'redmine_issue_templates' },
                    class: 'issue_template icon plugins') %> )
      </p>
  <% end %>
  <% if projects.any? %>
      <fieldset class='box box-white' id='global_issue_template_project_ids'
                style='<%= apply_all_projects ? 'opacity: 0.6' : '' %>'>
        <a class='collapsible collapsed template-help' data-template-help-target='all_projects'>
          <%= l(:project_list_associated_this_template, { applied: issue_template.projects.length, all: projects.length }) %>
        </a>
        <div id='all_projects' style='display: none;'>
        <p><%= check_all_links 'global_issue_template_project_ids' %></p>
        <legend><%= l(:label_project_plural) %></legend>
        <%= render_project_nested_lists(projects) do |p|
          content_tag('label', check_box_tag('global_issue_template[project_ids][]',
                                             p.id, issue_template.projects.to_a.include?(p),
                                             id: nil, disabled: apply_all_projects,
                                             checked: issue_template.projects.to_a.include?(p) ) + ' ' + h(p))
        end %>
        </div>
      </fieldset>
  <% end %>
  <%= hidden_field_tag 'global_issue_template[project_ids][]', '' %>
</div>

<%= submit_tag l(issue_template.new_record? ? :button_create : :button_save) %>
<%= link_to l(:button_cancel), { action: 'index' }, data: { confirm: l(:text_are_you_sure) } %>

<script>
  const baseUrl = "<%= url_for(controller: 'issue_templates', action: 'load_selectable_fields') %>"
  const template_id = "<%= issue_template&.id || '' %>"
  const template_type = 'global_issue_template'
  const tracker_pulldown_id = template_type + '_tracker_id'
  const base_builtin_fields = <%= issue_template.builtin_fields.html_safe %>
  const base_custom_fields = <%= custom_fields.html_safe %>
</script>

<% if builtin_fields_enable %>
<%= javascript_include_tag('vue.min', plugin: 'redmine_issue_templates') %>
<%= javascript_include_tag('template_fields', plugin: 'redmine_issue_templates') %>
<% end %>

<% if checklist_enabled %>
<%= javascript_include_tag('template_checklists', plugin: 'redmine_issue_templates') %>
<% end %>

app/views/global_issue_templates/index.html.erb
<h2 class='global_issue_template'><%=h "#{l(:global_issue_templates)}" %></h2>
<%= render partial: 'common/nodata', locals: { trackers: trackers } %>
<div class='contextual issue_templates'>
  <%= link_to(l(:label_new_templates),
              { controller: 'global_issue_templates', action: 'new' }, class: 'icon icon-add') %>
  <%= link_to(l(:label_settings),
              { controller: 'settings', action: 'plugin', id: 'redmine_issue_templates' },
              class: 'issue_template icon plugins') %>
</div>
<div style='clear: both;'></div>

<% if template_map.blank? %>
    <div class='template_box'>
      <%= l(:no_issue_templates_for_this_redmine) %>
    </div>
<% end %>
<% template_map.each_key do |tracker| %>
    <div class='template_box'>
      <h3 class='template_tracker'><%= tracker.name %></h3>

      <table class='list issues ui-sortable table-sortable'>
        <thead>
        <tr>
          <th>#</th>
          <th class='hideable'><%= l(:issue_template_name) %></th>
          <th><%= l(:label_preview) %></th>
          <th class='hideable'><%= l(:field_tracker) %></th>
          <th class='hideable'><%= l(:field_author) %></th>
          <th class='hideable'><%= l(:field_updated_on) %></th>
          <th><%= l(:field_is_default) %></th>
          <th><%= l(:label_enabled) %></th>
          <th><%=l(:button_sort)%></th>
        </tr>
        </thead>
        <tbody>
        <% template_map[tracker].sorted.each do |issue_template| %>
            <tr class='<%= cycle('odd', 'even') %> issue_template issue'>
              <td><%= link_to h(issue_template.id), { controller: 'global_issue_templates',
                                                      id: issue_template.id, action: 'show' },
                              { title: issue_template.title } %>
              </td>
              <td class='hideable template_title'>
                <%= link_to h(issue_template.title), { controller: 'global_issue_templates',
                                                         id: issue_template.id, action: 'show' },
                              { title: "#{html_escape(issue_template.note)}" } %>
              </td>
              <td>
                <div class='template_tooltip_wrapper'>
                  <a class='icon template_tooltip' title='<%= l(:label_preview) %>'></a>
                  <div class='wiki template_tooltip_body'>
                    <span class='title'><%= issue_template.title %></span>
                    <%= textilizable(issue_template.description) %>
                    <% if issue_template.related_link.present? %>
                      <hr/>
                      <%= link_to issue_template.link_title.present? ? issue_template.link_title : l(:issue_template_related_link, default: 'Related link'),
                          issue_template.related_link, target: '_blank', rel: 'nofollow noopener', class: 'external' %>
                    <% end %>
                  </div>
                </div>
                </a>
              </td>
              <td class='hideable'><%=h issue_template.tracker.name %></td>
              <td class='hideable'><%=h issue_template.author %></td>
              <td class='hideable'><%= format_time(issue_template.updated_on)%> </td>
              <td class='center'><%= checked_image issue_template.is_default? %></td>
              <td class='center'><%= checked_image issue_template.enabled? %></td>

              <td class='buttons'>
                <%= reorder_handle(issue_template, :url => url_for({ controller: 'global_issue_templates',
                                                             id: issue_template.id, action: 'update' })) %>
              </td>
            </tr>
        <% end %>
        </tbody>
      </table>
    </div>

    <%= javascript_tag do %>
      // NOTE: Sortable feature depends on Redmine's sorting jQuery plugin.
      $(function() { $('table.table-sortable tbody').positionedItems() })
    <% end %>
<% end %>

<a id='orphaned_template_link' class='icon template_tooltip orphaned_template_link template-help collapsible collapsed'
  title='<%= l(:orphaned_templates) %>'
  data-template-help-target='orphaned_templates'
  data-url='<%= orphaned_templates_global_issue_templates_path %>'>
  <%= l(:orphaned_templates, default: 'Orphaned Templates') %>
</a>

<div id='orphaned_templates' style='display: none'></div>

app/views/global_issue_templates/new.html.erb
<div class='contextual'>
  <%= link_to(l(:label_list_templates),
              { controller: 'global_issue_templates', action: 'index' }, class: 'icon icon-template') %>
</div>
<h2 class='global_issue_template'><%=h "#{l(:issue_templates)} / #{l(:button_add)}" %></h2>

<%= labelled_form_for :global_issue_template,  issue_template,
                      url: { controller: 'global_issue_templates', action: 'create' },
                      html: { id: 'global_issue_template-form',
                                  class: nil, multipart: false } do |f| %>

  <%= render 'form', { f: f, checklist_enabled: checklist_enabled,
                        trackers: trackers, projects: projects,
                        issue_template: issue_template, apply_all_projects: apply_all_projects,
                        custom_fields: custom_fields, builtin_fields_enable: builtin_fields_enable } %>
<% end %>

app/views/global_issue_templates/show.html.erb
<div class='contextual'>
<%= link_to l(:button_delete),
  { controller: 'global_issue_templates', action: 'destroy', id: issue_template },
    data: { confirm: l(:text_are_you_sure) },
    title: l(:enabled_template_cannot_destroy, default: 'Only disabled template can be destroyed.'),
    disabled: issue_template.enabled?, method: 'delete', class: 'icon icon-del template-disabled-link' %>
<%= link_to(l(:label_list_templates),
              { controller: 'global_issue_templates', action: 'index' }, class: 'icon icon-template') %>
</div>

<h2 class='global_issue_template'>
  <%= l(:global_issue_templates) %>: #<%= issue_template.id %> <%= issue_template.title %>
  <%= avatar(issue_template.author, size: '24') %>
</h2>

<%= labelled_form_for :global_issue_template,
                      issue_template,
                      url: { controller: 'global_issue_templates', action: 'update', id: issue_template },
                      html: { id: 'global_issue_template-form', class: nil,
                              multipart: false } do |f| %>
  <%= render 'form', { f: f, checklist_enabled: checklist_enabled, trackers: trackers,
                        issue_template: issue_template, projects: projects, apply_all_projects: apply_all_projects,
                        custom_fields: custom_fields, builtin_fields_enable: builtin_fields_enable } %>
<% end %>